package ap;

import ap.proof.{ExhaustiveProver, ConstraintSimplifier, ProofTree}
import ap.proof.goal.Goal
import ap.parser.PlainTranslator

class FileProver(file : java.io.File,
                 simplifier : ConstraintSimplifier,
                 output : Boolean) {

  private def println(str : => String) : unit = (if (output) Predef.println(str))
  
  val initialGoal : Goal = {
    println("Loading file " + file + " ...")
    val reader = new java.io.FileReader(file)
  
    val res = PlainTranslator(reader)
    reader.close
    res
  }
  
  val proofTree : ProofTree = {
    println("Proving ...")
    val res = new ExhaustiveProver(simplifier)(initialGoal)
    res
  }
  
}
