package ap;

import ap.proof.{TestProofTree, ConstraintSimplifier}
import ap.util.{Debug, Logic, APTestCase, PlainRange, FilterIt}

class TestProver(n : String) extends APTestCase(n) {

  def runTest = {
    n match {
      case "testFilesTrue" => testFilesTrue
      case "testFilesFalse" => testFilesFalse
    }
  }

  private val testcaseDir = new java.io.File ("testcases/")
  private val ctrueDir = new java.io.File (testcaseDir, "constraint_true")
  private val cfalseDir = new java.io.File (testcaseDir, "constraint_false")
  
  def testFilesTrue = {
    for (file <- FilterIt(ctrueDir.listFiles.elements,
                          (f:java.io.File) => f.isFile)) {
      val prover = new FileProver(file, ConstraintSimplifier.ALL_SIMPLIFIER, false)
      assert(prover.proofTree.closingConstraint.isTrue, file)
      TestProofTree.assertNormalisedTree(prover.proofTree)
    }
  }
 
  def testFilesFalse = {
    for (file <- FilterIt(cfalseDir.listFiles.elements,
                          (f:java.io.File) => f.isFile)) {
      val prover = new FileProver(file, ConstraintSimplifier.ALL_SIMPLIFIER, false)
      assert(prover.proofTree.closingConstraint.isFalse, file)
      TestProofTree.assertNormalisedTree(prover.proofTree)
    }
  }
}
