package ap.parameters;

object Param {
  
  case object ASSERTIONS extends Param {
    type Value = Boolean
    val defau : Boolean = true
  }
  
  case object PRINT_TREE extends Param {
    type Value = Boolean
    val defau : Boolean = false
  }
  
  case object SIMPLIFY_CONSTRAINTS extends Param {
    type Value = Boolean
    val defau : Boolean = true
  }
  
}

abstract class Param {
  
  type Value
  
  val defau : Value
  
  def apply(settings : Settings) : Value =
    settings(this).asInstanceOf[Value]
  
  def set(settings : Settings, v : Value) : unit =
    settings += (this, v)
    
}
