package ap.terfor;

/**
 * Extension of <code>Sorted</code> where also the actual <code>TermOrder</code>
 * can be queried
 */
trait SortedWithOrder[+T] extends Sorted[T] {

  val order : TermOrder
  
  val constants : Set[ConstantTerm]
  
  def isSortedBy(otherOrder : TermOrder) : Boolean =
    order.isSubOrderOf(otherOrder, constants)
  
}
