package ap.terfor.linearcombination;

import ap.basetypes.IdealInt
import ap.util.Debug

object ScalingIterator {
  def apply(coeff : IdealInt, delegate : Iterator[(IdealInt, Term)])
                               : Iterator[(IdealInt, Term)] = delegate match {
    case delegate : ScalingIterator => delegate * coeff
    case _ => coeff match {
                            case IdealInt.ONE => delegate
                            case IdealInt.ZERO => Iterator.empty
                            case _ => new ScalingIterator (coeff, delegate)
    }
  }
}

class ScalingIterator(coeff : IdealInt, delegate : Iterator[(IdealInt, Term)])
                                           extends Iterator[(IdealInt, Term)] {

  def *(newCoeff : IdealInt) = ScalingIterator(coeff * newCoeff, delegate)
  
  def hasNext = delegate.hasNext
  
  def next = {
    val (c, t) = delegate.next
    (c * coeff, t)
  }
  
}
