package ap.util;

object UnionSet {
  
  private val AC = Debug.AC_SET_UTILS

}

/**
 * A (lazy) <code>Set</code> that represents the union of two disjoint
 * <code>Set</code>s
 */
class UnionSet[A] (set1 : scala.collection.Set[A],
                   set2 : scala.collection.Set[A])
      extends scala.collection.Set[A] {

  def contains(x : A) : Boolean = (set1 contains x) || (set2 contains x)
  
  def size : Int = {
    ////////////////////////////////////////////////////////////////////////////
    Debug.assertInt(UnionSet.AC, Seqs.disjoint(set1, set2))
    ////////////////////////////////////////////////////////////////////////////
    set1.size + set2.size
  }
  
  def elements : Iterator[A] = set1.elements ++ set2.elements
  
}
